/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.datatypes.util;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import com.ibm.etools.c.CClassifier;
import com.ibm.etools.c.CDatatype;
import com.ibm.etools.c.CDerivableType;
import com.ibm.etools.c.datatypes.CBitField;
import com.ibm.etools.c.datatypes.CChar;
import com.ibm.etools.c.datatypes.CDouble;
import com.ibm.etools.c.datatypes.CEnumeration;
import com.ibm.etools.c.datatypes.CFloat;
import com.ibm.etools.c.datatypes.CFloating;
import com.ibm.etools.c.datatypes.CInt;
import com.ibm.etools.c.datatypes.CIntegral;
import com.ibm.etools.c.datatypes.CLong;
import com.ibm.etools.c.datatypes.CLongDouble;
import com.ibm.etools.c.datatypes.CLongLong;
import com.ibm.etools.c.datatypes.CShort;
import com.ibm.etools.c.datatypes.CSignedChar;
import com.ibm.etools.c.datatypes.CUnsignedChar;
import com.ibm.etools.c.datatypes.CUnsignedInt;
import com.ibm.etools.c.datatypes.CUnsignedLong;
import com.ibm.etools.c.datatypes.CUnsignedLongLong;
import com.ibm.etools.c.datatypes.CUnsignedShort;
import com.ibm.etools.c.datatypes.CVoid;
import com.ibm.etools.c.datatypes.CWchar;
import com.ibm.etools.c.datatypes.DatatypesPackage;
import com.ibm.etools.tdlang.TDLangClassifier;
import com.ibm.etools.tdlang.TDLangModelElement;

/**
 * <!-- begin-user-doc --> The <b>Switch </b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch doSwitch(object)}to invoke
 * the <code>caseXXX</code> method for each class of the model, starting with
 * the actual class of the object and proceeding up the inheritance hierarchy
 * until a non-null result is returned, which is the result of the switch. <!--
 * end-user-doc -->
 * 
 * @see com.ibm.etools.c.datatypes.DatatypesPackage
 * @generated
 */
public class DatatypesSwitch {
    /**
     * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected static DatatypesPackage modelPackage;

    /**
     * Creates an instance of the switch. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    public DatatypesSwitch() {
        if (modelPackage == null) {
            modelPackage = DatatypesPackage.eINSTANCE;
        }
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one
     * returns a non null result; it yields that result. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @return the first non-null result returned by a <code>caseXXX</code>
     *         call.
     * @generated
     */
    public Object doSwitch(EObject theEObject) {
        EClass theEClass = theEObject.eClass();
        if (theEClass.eContainer() == modelPackage) {
            switch (theEClass.getClassifierID()) {
            case DatatypesPackage.CLONG_DOUBLE: {
                CLongDouble cLongDouble = (CLongDouble) theEObject;
                Object result = caseCLongDouble(cLongDouble);
                if (result == null)
                    result = caseCFloating(cLongDouble);
                if (result == null)
                    result = caseCDatatype(cLongDouble);
                if (result == null)
                    result = caseCClassifier(cLongDouble);
                if (result == null)
                    result = caseCDerivableType(cLongDouble);
                if (result == null)
                    result = caseTDLangClassifier(cLongDouble);
                if (result == null)
                    result = caseTDLangModelElement(cLongDouble);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CFLOAT: {
                CFloat cFloat = (CFloat) theEObject;
                Object result = caseCFloat(cFloat);
                if (result == null)
                    result = caseCFloating(cFloat);
                if (result == null)
                    result = caseCDatatype(cFloat);
                if (result == null)
                    result = caseCClassifier(cFloat);
                if (result == null)
                    result = caseCDerivableType(cFloat);
                if (result == null)
                    result = caseTDLangClassifier(cFloat);
                if (result == null)
                    result = caseTDLangModelElement(cFloat);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CUNSIGNED_SHORT: {
                CUnsignedShort cUnsignedShort = (CUnsignedShort) theEObject;
                Object result = caseCUnsignedShort(cUnsignedShort);
                if (result == null)
                    result = caseCUnsignedInt(cUnsignedShort);
                if (result == null)
                    result = caseCInt(cUnsignedShort);
                if (result == null)
                    result = caseCIntegral(cUnsignedShort);
                if (result == null)
                    result = caseCDatatype(cUnsignedShort);
                if (result == null)
                    result = caseCClassifier(cUnsignedShort);
                if (result == null)
                    result = caseCDerivableType(cUnsignedShort);
                if (result == null)
                    result = caseTDLangClassifier(cUnsignedShort);
                if (result == null)
                    result = caseTDLangModelElement(cUnsignedShort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CDOUBLE: {
                CDouble cDouble = (CDouble) theEObject;
                Object result = caseCDouble(cDouble);
                if (result == null)
                    result = caseCFloating(cDouble);
                if (result == null)
                    result = caseCDatatype(cDouble);
                if (result == null)
                    result = caseCClassifier(cDouble);
                if (result == null)
                    result = caseCDerivableType(cDouble);
                if (result == null)
                    result = caseTDLangClassifier(cDouble);
                if (result == null)
                    result = caseTDLangModelElement(cDouble);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CSHORT: {
                CShort cShort = (CShort) theEObject;
                Object result = caseCShort(cShort);
                if (result == null)
                    result = caseCInt(cShort);
                if (result == null)
                    result = caseCIntegral(cShort);
                if (result == null)
                    result = caseCDatatype(cShort);
                if (result == null)
                    result = caseCClassifier(cShort);
                if (result == null)
                    result = caseCDerivableType(cShort);
                if (result == null)
                    result = caseTDLangClassifier(cShort);
                if (result == null)
                    result = caseTDLangModelElement(cShort);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CUNSIGNED_LONG_LONG: {
                CUnsignedLongLong cUnsignedLongLong = (CUnsignedLongLong) theEObject;
                Object result = caseCUnsignedLongLong(cUnsignedLongLong);
                if (result == null)
                    result = caseCUnsignedInt(cUnsignedLongLong);
                if (result == null)
                    result = caseCInt(cUnsignedLongLong);
                if (result == null)
                    result = caseCIntegral(cUnsignedLongLong);
                if (result == null)
                    result = caseCDatatype(cUnsignedLongLong);
                if (result == null)
                    result = caseCClassifier(cUnsignedLongLong);
                if (result == null)
                    result = caseCDerivableType(cUnsignedLongLong);
                if (result == null)
                    result = caseTDLangClassifier(cUnsignedLongLong);
                if (result == null)
                    result = caseTDLangModelElement(cUnsignedLongLong);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CLONG_LONG: {
                CLongLong cLongLong = (CLongLong) theEObject;
                Object result = caseCLongLong(cLongLong);
                if (result == null)
                    result = caseCInt(cLongLong);
                if (result == null)
                    result = caseCIntegral(cLongLong);
                if (result == null)
                    result = caseCDatatype(cLongLong);
                if (result == null)
                    result = caseCClassifier(cLongLong);
                if (result == null)
                    result = caseCDerivableType(cLongLong);
                if (result == null)
                    result = caseTDLangClassifier(cLongLong);
                if (result == null)
                    result = caseTDLangModelElement(cLongLong);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CUNSIGNED_LONG: {
                CUnsignedLong cUnsignedLong = (CUnsignedLong) theEObject;
                Object result = caseCUnsignedLong(cUnsignedLong);
                if (result == null)
                    result = caseCUnsignedInt(cUnsignedLong);
                if (result == null)
                    result = caseCInt(cUnsignedLong);
                if (result == null)
                    result = caseCIntegral(cUnsignedLong);
                if (result == null)
                    result = caseCDatatype(cUnsignedLong);
                if (result == null)
                    result = caseCClassifier(cUnsignedLong);
                if (result == null)
                    result = caseCDerivableType(cUnsignedLong);
                if (result == null)
                    result = caseTDLangClassifier(cUnsignedLong);
                if (result == null)
                    result = caseTDLangModelElement(cUnsignedLong);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CLONG: {
                CLong cLong = (CLong) theEObject;
                Object result = caseCLong(cLong);
                if (result == null)
                    result = caseCInt(cLong);
                if (result == null)
                    result = caseCIntegral(cLong);
                if (result == null)
                    result = caseCDatatype(cLong);
                if (result == null)
                    result = caseCClassifier(cLong);
                if (result == null)
                    result = caseCDerivableType(cLong);
                if (result == null)
                    result = caseTDLangClassifier(cLong);
                if (result == null)
                    result = caseTDLangModelElement(cLong);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CUNSIGNED_CHAR: {
                CUnsignedChar cUnsignedChar = (CUnsignedChar) theEObject;
                Object result = caseCUnsignedChar(cUnsignedChar);
                if (result == null)
                    result = caseCChar(cUnsignedChar);
                if (result == null)
                    result = caseCIntegral(cUnsignedChar);
                if (result == null)
                    result = caseCDatatype(cUnsignedChar);
                if (result == null)
                    result = caseCClassifier(cUnsignedChar);
                if (result == null)
                    result = caseCDerivableType(cUnsignedChar);
                if (result == null)
                    result = caseTDLangClassifier(cUnsignedChar);
                if (result == null)
                    result = caseTDLangModelElement(cUnsignedChar);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CCHAR: {
                CChar cChar = (CChar) theEObject;
                Object result = caseCChar(cChar);
                if (result == null)
                    result = caseCIntegral(cChar);
                if (result == null)
                    result = caseCDatatype(cChar);
                if (result == null)
                    result = caseCClassifier(cChar);
                if (result == null)
                    result = caseCDerivableType(cChar);
                if (result == null)
                    result = caseTDLangClassifier(cChar);
                if (result == null)
                    result = caseTDLangModelElement(cChar);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CVOID: {
                CVoid cVoid = (CVoid) theEObject;
                Object result = caseCVoid(cVoid);
                if (result == null)
                    result = caseCDatatype(cVoid);
                if (result == null)
                    result = caseCClassifier(cVoid);
                if (result == null)
                    result = caseCDerivableType(cVoid);
                if (result == null)
                    result = caseTDLangClassifier(cVoid);
                if (result == null)
                    result = caseTDLangModelElement(cVoid);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CWCHAR: {
                CWchar cWchar = (CWchar) theEObject;
                Object result = caseCWchar(cWchar);
                if (result == null)
                    result = caseCChar(cWchar);
                if (result == null)
                    result = caseCIntegral(cWchar);
                if (result == null)
                    result = caseCDatatype(cWchar);
                if (result == null)
                    result = caseCClassifier(cWchar);
                if (result == null)
                    result = caseCDerivableType(cWchar);
                if (result == null)
                    result = caseTDLangClassifier(cWchar);
                if (result == null)
                    result = caseTDLangModelElement(cWchar);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CINT: {
                CInt cInt = (CInt) theEObject;
                Object result = caseCInt(cInt);
                if (result == null)
                    result = caseCIntegral(cInt);
                if (result == null)
                    result = caseCDatatype(cInt);
                if (result == null)
                    result = caseCClassifier(cInt);
                if (result == null)
                    result = caseCDerivableType(cInt);
                if (result == null)
                    result = caseTDLangClassifier(cInt);
                if (result == null)
                    result = caseTDLangModelElement(cInt);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CUNSIGNED_INT: {
                CUnsignedInt cUnsignedInt = (CUnsignedInt) theEObject;
                Object result = caseCUnsignedInt(cUnsignedInt);
                if (result == null)
                    result = caseCInt(cUnsignedInt);
                if (result == null)
                    result = caseCIntegral(cUnsignedInt);
                if (result == null)
                    result = caseCDatatype(cUnsignedInt);
                if (result == null)
                    result = caseCClassifier(cUnsignedInt);
                if (result == null)
                    result = caseCDerivableType(cUnsignedInt);
                if (result == null)
                    result = caseTDLangClassifier(cUnsignedInt);
                if (result == null)
                    result = caseTDLangModelElement(cUnsignedInt);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CBIT_FIELD: {
                CBitField cBitField = (CBitField) theEObject;
                Object result = caseCBitField(cBitField);
                if (result == null)
                    result = caseCDatatype(cBitField);
                if (result == null)
                    result = caseCClassifier(cBitField);
                if (result == null)
                    result = caseCDerivableType(cBitField);
                if (result == null)
                    result = caseTDLangClassifier(cBitField);
                if (result == null)
                    result = caseTDLangModelElement(cBitField);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CSIGNED_CHAR: {
                CSignedChar cSignedChar = (CSignedChar) theEObject;
                Object result = caseCSignedChar(cSignedChar);
                if (result == null)
                    result = caseCChar(cSignedChar);
                if (result == null)
                    result = caseCIntegral(cSignedChar);
                if (result == null)
                    result = caseCDatatype(cSignedChar);
                if (result == null)
                    result = caseCClassifier(cSignedChar);
                if (result == null)
                    result = caseCDerivableType(cSignedChar);
                if (result == null)
                    result = caseTDLangClassifier(cSignedChar);
                if (result == null)
                    result = caseTDLangModelElement(cSignedChar);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            case DatatypesPackage.CENUMERATION: {
                CEnumeration cEnumeration = (CEnumeration) theEObject;
                Object result = caseCEnumeration(cEnumeration);
                if (result == null)
                    result = caseCIntegral(cEnumeration);
                if (result == null)
                    result = caseCDatatype(cEnumeration);
                if (result == null)
                    result = caseCClassifier(cEnumeration);
                if (result == null)
                    result = caseCDerivableType(cEnumeration);
                if (result == null)
                    result = caseTDLangClassifier(cEnumeration);
                if (result == null)
                    result = caseTDLangModelElement(cEnumeration);
                if (result == null)
                    result = defaultCase(theEObject);
                return result;
            }
            default:
                return defaultCase(theEObject);
            }
        }
        return defaultCase(theEObject);
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CLong Double</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CLong Double</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCLongDouble(CLongDouble object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CFloating</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CFloating</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCFloating(CFloating object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CFloat</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CFloat</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCFloat(CFloat object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CUnsigned Short</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CUnsigned Short</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCUnsignedShort(CUnsignedShort object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CDouble</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CDouble</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCDouble(CDouble object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CShort</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CShort</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCShort(CShort object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CUnsigned Long Long</em>'. <!-- begin-user-doc --> This
     * implementation returns null; returning a non-null result will terminate
     * the switch. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CUnsigned Long Long</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCUnsignedLongLong(CUnsignedLongLong object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CLong Long</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CLong Long</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCLongLong(CLongLong object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CUnsigned Long</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CUnsigned Long</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCUnsignedLong(CUnsignedLong object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CIntegral</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CIntegral</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCIntegral(CIntegral object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CLong</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CLong</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCLong(CLong object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CUnsigned Char</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CUnsigned Char</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCUnsignedChar(CUnsignedChar object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CChar</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CChar</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCChar(CChar object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CVoid</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CVoid</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCVoid(CVoid object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CWchar</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CWchar</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCWchar(CWchar object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CInt</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CInt</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCInt(CInt object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CUnsigned Int</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CUnsigned Int</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCUnsignedInt(CUnsignedInt object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CBit Field</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CBit Field</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCBitField(CBitField object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CSigned Char</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CSigned Char</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCSignedChar(CSignedChar object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>CEnumeration</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>CEnumeration</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCEnumeration(CEnumeration object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>TD Lang Model Element</em>'. <!-- begin-user-doc --> This
     * implementation returns null; returning a non-null result will terminate
     * the switch. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>TD Lang Model Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseTDLangModelElement(TDLangModelElement object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>TD Lang Classifier</em>'. <!-- begin-user-doc --> This
     * implementation returns null; returning a non-null result will terminate
     * the switch. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>TD Lang Classifier</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseTDLangClassifier(TDLangClassifier object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Classifier</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Classifier</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCClassifier(CClassifier object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Derivable Type</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Derivable Type</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCDerivableType(CDerivableType object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>Datatype</em>'. <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>Datatype</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseCDatatype(CDatatype object) {
        return null;
    }

    /**
     * Returns the result of interpretting the object as an instance of '
     * <em>EObject</em>'. <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch, but this is
     * the last case anyway. <!-- end-user-doc -->
     * 
     * @param object
     *            the target of the switch.
     * @return the result of interpretting the object as an instance of '
     *         <em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
    public Object defaultCase(EObject object) {
        return null;
    }

} //DatatypesSwitch
