// ****************************************************************
//
//   IBM Confidential
//   OCO Source Materials
//   <<com.ibm.etools.cobol.preference.ui>>
//   (C) Copyright IBM Corp. 2004 - All Rights Reserved.
//   US Government Users Restricted Rights - Use, duplication or disclosure
//   restricted by GSA ADP Schedule Contract with IBM Corp.
//
// ****************************************************************

package com.ibm.etools.cobol.preference.ui.plugin;

/**
 * Insert the type's description here.
 * Creation date: (7/1/2002 11:06:01 AM)
 * @author: Administrator
 */
import java.text.MessageFormat;
import java.util.Hashtable;

import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.Plugin;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.plugin.AbstractUIPlugin;

import com.ibm.etools.cobol.plugin.CobolPlugin;
import com.ibm.etools.logging.util.IPluginHelper;
import com.ibm.etools.logging.util.MsgLogger;
import com.ibm.etools.logging.util.PluginHelperImpl;


public class CobolPreferenceUIPlugin extends AbstractUIPlugin implements IPluginHelper {	

	private static final String copyright = "(c) Copyright IBM Corporation 2004.";

	  /**
	  * Use this severity to log any event associated with
	  * a task that has succeeded.
	  */
	  public static final int OK = 0;

	  /**
	  * Use this severity to log any event associated with
	  * a task that has succeeded but with information the
	  * user may find useful.
	  */
	  public static final int INFO = 1;

	  /**
	  * Use this severity to log any event associated with
	  * a task that has succeeded but with side effects
	  * that may surprise the user.
	  */
	  public static final int WARNING = 2;

	  /**
	  * Use this severity to log any event associated with
	  * a task that has failed.
	  */
	  public static final int ERROR = 4;
	
	/*
	 * Plugin.xml constants
	 */
 	public static final String PLUGIN_ID="com.ibm.etools.cobol.preferences.ui";//$NON-NLS-1$
 
	/**
	 * Keep track of the singleton.
	 */
	private static CobolPreferenceUIPlugin inst;

	/**
	 * Logger helper.
	 */
	protected static MsgLogger msgLogger; // Logger that does real Tracing



/**
 * CPlugin constructor comment.
 */
public CobolPreferenceUIPlugin() {	
	super();
	if (inst == null) inst = this;
}

/**
 * Returns the plugin singleton.
 */
public static CobolPreferenceUIPlugin getPlugin() {
	return inst;
}

public void setMsgLoggerConfig(Hashtable msgLoggerConfig){
   CobolPlugin.getMsgLogger().setMsgLoggerConfig(msgLoggerConfig);
}

public Hashtable getMsgLoggerConfig(Plugin plugin) { 
    return (new PluginHelperImpl().getMsgLoggerConfig(plugin));
}

public Hashtable getMsgLoggerConfig() {
    return getMsgLoggerConfig(this);
}


/**
 * Returns the workbench used by the example
 *
 * This method is internal to the plugin and must not be called
 * by any other plugins.
 */
public IWorkbench getWorkbench() {
	return PlatformUI.getWorkbench();
}

/**
 * Returns the plugin singleton.
 */
static public CobolPreferenceUIPlugin getDefault() {
	return inst;
}

/**
 * Returns the translated String found with the given key.
 *
 * @param key java.lang.String
 * @return java.lang.String
 */
public static String getResource(String key) {
	try {
		return Platform.getResourceString(getDefault().getBundle(), key);
	} catch (Exception e) {
		return key;
	}
}
/**
 * Returns the translated String found with the given key,
 * and formatted with the given arguments using java.text.MessageFormat.
 *
 * @param key java.lang.String
 * @param arguments java.lang.Object[]
 * @return java.lang.String
 */
public static String getResource(String key, Object[] arguments) {
	try {
		String text = getResource(key);
		return MessageFormat.format(text, arguments);
	} catch (Exception e) {
		return key;
	}
}
}
